#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>

#define THREAD_NR	16

static pthread_once_t once = PTHREAD_ONCE_INIT;

static void call_me_once(void)
{
	printf("Called\n");
}

static void *worker(void *unused)
{
	(void) unused;
	pthread_once(&once, &call_me_once);
	return NULL;
}

int main(void)
{
	pthread_t ths[THREAD_NR];

	for (int i = 0; i != THREAD_NR; ++i) {
		const int rc = pthread_create(&ths[i], NULL, &worker, NULL);

		if (rc) {
			perror("pthread_create");
			exit(2);
		}
	}

	for (int i = 0; i != THREAD_NR; ++i)
		pthread_join(ths[i], NULL);

	return 0;
}
